program nansi;

uses
  SysUtils;

const
  NANSI_CLS = '2J';
  NANSI_NORMAL = '0m';
  NANSI_BOLD = '1m';
  NANSI_FG = '30m';
  NANSI_BG = '40m';
  Colors: array[0..7] of string = (
    'black', 'red', 'green', 'brown', 'blue', 'magenta', 'cyan', 'gray'
  );

var
  L, I, J: Integer;
  S: string;

procedure NansiWrite(NANSISeq: string);

begin
  Write(Chr(27), '[', NANSISeq);
end;

procedure NansiWriteColor(Ground: string; Colour: Integer);

var
  NANSISeq: string;
  Bold: Boolean;

begin
  if Ground = 'fg' then
    NANSISeq := NANSI_FG
  else
    NANSISeq := NANSI_BG;
  Bold := False;
  if Colour > 7 then begin
    Colour := Colour - 7;
    if Ground = 'fg' then
      Bold := True;
  end;
  NANSISeq := StringReplace(NANSISeq, '0', IntToStr(Colour), []);
  if Bold then begin
    NANSISeq := StringReplace(NANSISeq, 'm', '', []);
    NANSISeq := NANSISeq + ';' + NANSI_BOLD;
  end;
  NansiWrite(NANSISeq);
end;

begin
  NansiWrite(NANSI_CLS);
  Writeln('NANSI colors:'); Writeln;
  for I := 0 to 7 do begin
    S := Colors[I]; L := Length(S);
    for J := 1 to 7 - L do
      S := S + ' ';
    NansiWrite(NANSI_NORMAL); Write(S, ':  ');
    NansiWriteColor('bg', I);
    for J := 0 to 14 do begin
      NansiWriteColor('fg', J); Write('XX');
      if J < 14 then
        Write('  ');
    end;
    Writeln;
  end;
  NansiWrite(NANSI_NORMAL);
  Writeln; Writeln;
end.
